#include <asm/unistd_64.h>
#include <errno.h>
#include <stdint.h>
#include <unistd.h>

ssize_t my_write(int fd, const void *buf, size_t count) {
  int64_t result;
  asm (
      "syscall"
      : /* outputs */
        "=a" (result)
      : /* inputs */
        "a" (__NR_write), // rax = syscall number
        "D" (fd),         // rdi = arg1
        "S" (buf),        // rsi = arg2
        "d" (count)       // rdx = arg3
      : /* clobbers */
        "cc",
        "r11",
        "rcx"
      );
  if (result >= -4095 && result <= -1) {
    errno = -result;
    return -1;
  } else {
    return result;
  }
}

static const char msg[] = "Hello world!\n";

int main() {
  my_write(STDOUT_FILENO, msg, sizeof(msg) - 1);
  return 0;
}
